#ifndef colorer_h
#define colorer_h

typedef struct KEYEDVALUE
{
	char key[256];
	char value[256];
} keyedValue;

typedef struct KEYEDVALUEARRAY
{
	keyedValue* head;
	int size;
} keyedValueArray;

void
stylePrint(char* style, char* text);
void
stylePrintSkipLast(char* style, char* text);
void
stylePrintSkipLastAndLink(char* style, char* text, keyedValueArray* arr);
void
stylePrintAndLinkToOr(char* style, char* text, keyedValueArray* arr, char* key);
void
putInBuffer(char* text);
void
printBuffer();
void
unputBuffer();
void
freeBuffer();
char**
checkCommandLine(int argc, char *argv[ ], char *envp[ ]);
void
error(char* message);
void
helpScreen();

int
readLinksFrom(char* linkspath);
char
readLinksFile(FILE* links);

char*
getValue(keyedValueArray* arr, char* key);
void
freeKeyedValueArray(keyedValueArray* arr);
void
addKeyAndValue(keyedValueArray* arr, char* key, char* value);

FILE*
convertFileToHTML(FILE* fin);

const char*
char2html(char ch);

extern keyedValueArray instLinks;
extern keyedValueArray dirLinks;
extern keyedValueArray symLinks;
extern char* buffer;
extern int bufferSize;
extern char* csspath;
extern char* linkspath;
extern char* name;
extern int fillTabs;
extern int keywordsDetected;
extern char sxInstBuf[];
extern char sxTemplateBuf[];
extern char sxOperandsString[];
#endif
