B               [0-1]
D               [0-9]
L               [A-Z_]
LD              [A-Z_0-9]
NLD             [^A-Z_0-9]
ID              {L}{LD}*
WS              [ \t]*
H               [A-F0-9]
E               [e][+-]?{D}+
GT              &gt;?
LT              &lt;?
AMP             &amp;?
QUO             &quot;?
SPEC            {GT}|{LT}|{AMP}
CHR             \\.|[^\\'\n]|(\\)?{QUO}|{SPEC}
Num1            0x{H}+
Num2            %{B}+
Num3            '{CHR}'
Num4            {D}+{E}
Num5            {D}*"."{D}+({E})?
Num6            {D}+"."{D}*({E})?
Num7            [bdh]\'{H}+\'
Num8            {D}{H}*[bdh]?
Num9            "$"{H}+
PRE1            "<PRE>"
PRE2            "</PRE>"
HEAD            "<HEAD>"
Comm            ;[^\n]*
Str             {LT}([a-z0-9^\n]|".")+{GT}
Sym             ([@!|=~*/%+]|"^"|"-"|{GT}|{LT}|{AMP})+|"("|")"|"#"|(!{WS}(OPTION|WDT|R[A-G]))
Sym2            w|m|high|low|upper|IND|RTCC|WREG|PC|STATUS|C|DC|Z|PD|TO|PA0|PA1|PA2|FSR|R[A-G]
Num             {Num1}|{Num2}|{Num3}|{Num4}|{Num5}|{Num6}|{Num7}|{Num8}|{Num9}
Dir2            "$"|#include|#define|#undefine
PICInst         ADDLW|ANDLW|CALL|CLRWDT|GOTO|IORLW|MOVLW|OPTION|RETFIE|RETLW|RETURN|SLEEP|SUBLW|TRIS|XORLW|ADDWF|ANDWF|CLRF|CLRW|COMF|DECF|DECFSZ|INCF|INCFSZ|IORWF|MOVF|MOVWF|NOP|RLF|RRF|SUBWF|SWAPF|XORWF|BCF|BSF|BTFSC|BTFSS|ADDCF|ADDDCF|BC|BDC|BNC|BNDC|BNZ|BZ|CLRC|CLRDC|CLRZ|LCALL|LGOTO|MOVFW|NEGF|SETC|SETDC|SETZ|SKPC|SKPDC|SKPNC|SKPNDC|SKPNZ|SKPZ|SUBCF|SUBDCF|TSTF
PICDir          CONSTANT|END|EQU|ERROR|ERRORLEVEL|LIST|MESSG|NOLIST|ORG|PAGE|PROCESSOR|RADIX|SET|SPACE|SUBTITLE|TITLE|VARIABLE|ELSE|ENDIF|ENDW|IF|IFDEF|IFNDEF|WHILE|DATA|__BADRAM|CBLOCK|__CONFIG|DA|DATA|DB|DE|DT|DW|ENDC|FILL|__IDLOCS|__MAXRAM|RES|ENDM|EXITM|EXPAND|LOCAL|MACRO|NOEXPAND|BANKISEL|BANKSEL|CODE|EXTERN|GLOBAL|IDATA|PAGESEL|UDATA|UDATA_ACS|UDATA_OVR|UDATA_SHR
PICDetect       ADDLW|ANDLW|CLRWDT|GOTO|IORLW|MOVLW|RETFIE|RETLW|SUBLW|TRIS|XORLW|ADDWF|ANDWF|CLRF|CLRW|COMF|DECF|DECFSZ|INCF|INCFSZ|IORWF|MOVF|MOVWF|NOP|RLF|RRF|SUBWF|SWAPF|XORWF|BCF|BSF|BTFSC|BTFSS|ADDCF|ADDDCF|BC|BDC|BNC|BNDC|BNZ|BZ|CLRC|CLRDC|CLRZ|LCALL|LGOTO|MOVFW|NEGF|SETC|SETDC|SETZ|SKPC|SKPDC|SKPNC|SKPNDC|SKPNZ|SKPZ|SUBCF|SUBDCF|TSTF
SXInst          SB|SC|SZ|ADD|AND|CLC|CLR|CLZ|DEC|INC|JMP|MOV|NOP|NOT|RET|SNB|SNC|SNZ|SUB|XOR|BANK|CALL|CLRB|RETI|RETP|RETW|SETB|SKIP|SWAP|TEST|DECSZ|INCSZ|IREAD|MOVSZ|RETIW|SLEEP|MODE|RR|RL|OR|PAGE
SXDir           DATA|DS|RES|DW|EQU|ORG|END|SET|ENDM|EXITM|IF|IFDEF|IFNDEF|ELSE|ENDIF|EXPAND|NOEXPAND|LIST|DEVICE|ID|RESET|SPAC|ZERO|LOCAL|LPAGE|MACRO|RADIX|TITLE|STITLE|INCLUDE|SUBTITL|LIST|PROCESSOR
SXDetect        SC|SZ|CLC|CLR|CLZ|DEC|INC|JMP|MOV|NOP|RET|SNB|SNC|SNZ|WDT|XOR|CLRB|RETI|RETP|RETW|SETB|DECSZ|INCSZ|IREAD|MOVSZ|RETIW|RR|RL
SXKEYInst       ADDB|CJA|CJAE|CJB|CJBE|CJE|CJNE|CLRB|CLZ|CSA|CSAE|CSB|CSBE|CSE|CSNE|IJNZ|SNZ|SNC|STC|STZ|JC|JNC|JNZ|JZ|SZ|SC|SUBB|LJMP|MOVB|DJNZ|JNB|JB|TSTN
SXKEYDir        WATCH|ENDR|ERROR|BREAK|CASE|FREQ
SXKEYDetect     {SXKEYInst}
Dir             {PICDir}|{SXDir}|{SXKEYDir}
Detect          {NLD}({PICDetect}|{SXDetect}|{SXKEYDetect}){NLD}
Label           (:{WS}[{ID}^{Inst}])|([{ID}^{Inst}]{WS}:)
SXOpElement1	","{WS}((({LT}|{GT}|"+"|"-"|"/")*{WS})|"#").
SXOpElement2	[+-]?{WS}[wm]{NLD}
SXOpElement3	"!"{WS}(option|wdt|r{L}){NLD}
SXOpElement4	","{WS}("w"|"m"){NLD}
SXOpElement	{SXOpElement1}|{SXOpElement2}|{SXOpElement3}|{SXOpElement4}

%x PRE
%x ASM
%x TOKEN
%x TOKEN_SX_OP
%x TOKENFLUSH
%x STR_STATE
%x STR_STATE2
%x FLUSH
%{

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define yywrap() 1

#include "colorer.h"

%}

%%
<INITIAL>{HEAD} {
                        ECHO;
                        if(csspath != NULL)
                        {
                                fprintf(yyout, "\n<LINK REL=STYLESHEET HREF=\"%s\" TYPE=\"text/css\">\n", csspath);
                        }
                }

<INITIAL>{PRE1} {
                        ECHO;
                        BEGIN(PRE);
                }
<INITIAL>.      { //echo unrecognized text
                        ECHO;
                }


<PRE>{Detect}   {       //enter in coloring mode only
                        //if {Detect} pattern was encountered 
                        //(instructions that have a unique spelling)
                        putInBuffer(yytext);
                        unputBuffer();
                        keywordsDetected = 1;
                        BEGIN(ASM);
                }
<PRE>{PRE2}|<EOF>       {
                        printBuffer();
                        ECHO;
                        BEGIN(INITIAL);
                }
<PRE>\n|.       { //echo unrecognized text to buffer
                        putInBuffer(yytext);
                        //check size of buffer - it can't exceed 10000 bytes
                        //without detection
                        if(bufferSize >= 10000)
                        {
                        	printBuffer();
                        	BEGIN(FLUSH);
                        }
                }

<FLUSH><PRE1>	{	ECHO;
			BEGIN(INITIAL);
		}

<FLUSH>.	{	ECHO;
		}

<ASM>{PRE2}     { //quit from ASM state if </PRE> encountered
                        ECHO;
                        BEGIN(INITIAL);
                }
<ASM>{L}        { //start of a keyword - enter TOKEN state
			yyless(0);
                        BEGIN(TOKEN);
                }
<ASM>{Str}      { //string
                        stylePrint("Str", yytext);
                }
<ASM>{Sym}.     { //symbol (operators)
                        //stylePrint("Sym", yytext);
                        stylePrintSkipLastAndLink("Sym", yytext, &symLinks);
                }
<ASM>{Num}{NLD} { //number followed by non-digit-non-letter
                        stylePrintSkipLast("Num", yytext);
                }

<ASM>{Dir2}{NLD} { //directives starting from # or $
                        stylePrintSkipLastAndLink("Dir", yytext, &dirLinks);
                }
<ASM>{Comm}     { //comment
                        stylePrint("Comm", yytext);
                }
<ASM>{QUO}	{ //start of string
                        putInBuffer(yytext);
                        BEGIN(STR_STATE);
		}
<ASM>'		{ //start of string
                        putInBuffer(yytext);
                        BEGIN(STR_STATE2);
		}
<ASM>{Label}|.	{ //|{Bit}|.    
			//echo unrecognized text
                        ECHO;
                }
<STR_STATE>{QUO} { //end of string
                        putInBuffer(yytext);
                        stylePrint("Str", buffer);
                        freeBuffer();
                        BEGIN(ASM);
		}
<STR_STATE>\\.|\\{QUO}|. {
		        putInBuffer(yytext);
		}
<STR_STATE2>' { //end of string
                        putInBuffer(yytext);
                        stylePrint("Str", buffer);
                        freeBuffer();
                        BEGIN(ASM);
		}
<STR_STATE2>\\.|. {
		        putInBuffer(yytext);
		}

<TOKEN>{Sym2}{NLD}  { //symbols starting from a letter
                        //followed by non-digit-non-letter
                        //stylePrintSkipLast("Sym", yytext);
                       	stylePrintSkipLastAndLink("Sym", yytext, &symLinks);
                        if(yytext[yyleng-1] == '.')
                        {
                        	fprintf(yyout, ".");
                        	yyinput(); //remove the point from stream (bit separation)
                        }

                        BEGIN(ASM);
                }
<TOKEN>{PICInst}{NLD}      { //pic instructions
                        //followed by non-digit-non-letter
                        stylePrintSkipLastAndLink("Inst", yytext, &instLinks);
                        BEGIN(ASM);
                }
<TOKEN>({SXInst}|{SXKEYInst})[^A-Z_0-9#,'-'+!] {
		/*
			SX instructions are treated specially. To determine
			exactly what instruction is detected it is necessary
			to look at the operands of the instruction.

			We extract only a number of elements from operands:
                        ',': ''           'w'          
			   | '-'                       
			   | '+'          'm'          
			   | '<'                       
			   | '>'          '- w'        
			   | '/'                       
			   | '#'          '+ w'        
			   | 'w'                       
			   | 'm'          '!': 'option'
			                     | 'R'...  
			                     | 'wdt'   

			In this way an instrucion template is extracted, which
			is then used as a suffix to the mnemonic, when looking
			for a corresponding URL describing the instruction.

			For example,

			mov w, #1  translates to-> mov_w,#
			mov w, fr-w   		-> mov_w,-w
			jmp pc+w      		-> jmp_+w
			clr !wdt      		-> clr_!wdt
			mov w, >>fr   		-> mov_w,>>
			clr reg			-> clr
			clr w			-> clr_w
			mov !option, #%00001111 -> mov_!option,#
			mov !RA, w		-> mov_!r,w
			mov !RA, #$FF		-> mov_!r,#

			If a full instruction template isn't found in the links
			vocabulary, then the search is repeated using only
			the mnemonic
		*/
			yyless(yyleng-1); //put look-ahead character back on stream
			sxInstBuf[31] = '\0';	//initialize last character to 0
			sxTemplateBuf[31] = '\0';  //to use strncpy(dest, source, 31)
			//1. store the mnemonic in sxInstBuf
			strncpy(sxInstBuf, yytext, 31);
			//sxInstBuf[strlen(sxInstBuf)-1] = '\0'; //remove last (look-ahead) character
			//2. initialize buffer for operands
                        sxOperandsString[0] = '\0';
                        strcpy(sxTemplateBuf, sxInstBuf);
                        strncat(sxTemplateBuf, "_", 31-strlen(sxTemplateBuf));
                                /* append underscore to template
                        	(between mnemonic and stripped operands) */
			//3. switch state to TOKEN_SX_OP to read operands
                        BEGIN(TOKEN_SX_OP);
		}

<TOKEN>{Dir}{NLD}       { //directives starting from a letter
                        //and followed by non-digit-non-letter
                        stylePrintSkipLastAndLink("Dir", yytext, &dirLinks);
                        BEGIN(ASM);
                }

<TOKEN>.        {       //switch to TOKENFLUSH state (ignoring rest of keyword)
			yyless(0);
                        BEGIN(TOKENFLUSH);
                }
<TOKENFLUSH>{LD}*(".")?|\n|. { //switch to ASM state after keyword or line end
			//or unrecognized pattern
                        ECHO;
                        BEGIN(ASM);
                }

<TOKEN_SX_OP>{SXOpElement} {
		  	int len;
		  	int i;
		  	int j;

			yyless(yyleng-1); //put look-ahead character back on stream
		 	//append all read characters to the buffer
		  	strncat(sxOperandsString, yytext, 255-strlen(sxOperandsString));
		  	//copy detected element stripped of tabs and spaces to
		  	//the template
		  	len = strlen(sxTemplateBuf);
		  	i = 0;
		  	j = 0;
		  	while(len < 31 && i < yyleng)
		  	{
		  		if(yytext[i] != ' ' && yytext[i] != '\t')
		  		{
		  			//not white space
	  				sxTemplateBuf[len++] = yytext[i];
		  			if(++j == 2)
		  			{
		  				/*two characters copied to template,
		  				check if these are !R, in which
		  				case inore all the rest
                                                */
                                                if(sxTemplateBuf[len-2] == '!' &&
                                                (sxTemplateBuf[len-1] == 'r' ||
                                                sxTemplateBuf[len-1] == 'R'))
                                                {
                                                	break;
                                                }
		  			}
		  		}
		  		i++;
		  	}
		  	sxTemplateBuf[len] = '\0'; //ensure string termination
		  	if(yytext[yyleng-1] == '#')
		  	{
		  		goto TOKEN_SX_OP_END;
		  	}
		}

<TOKEN_SX_OP>";"|"\n"|EOF {  /*
			end of operands detected, digest results and
			print them, then unput yytext and switch back
			to ASM state
                        */
                        int i;
                        yyless(0); //put all yytext back on stream to rescan
TOKEN_SX_OP_END:
                        //remove underscore in template if it's last
                        if(sxTemplateBuf[strlen(sxTemplateBuf)-1] == '_')
                        {
                        	sxTemplateBuf[strlen(sxTemplateBuf)-1] = '\0';
                        }
                        // debug lines to see how an instruction is converted to
                        // template
                        /* stylePrint("Inst", sxInstBuf);
                        stylePrint("Inst", "<");
                        stylePrint("Inst", sxTemplateBuf);
                        stylePrint("Inst", ">");*/

                        //add style tags and links to the mnemonic
			stylePrintAndLinkToOr("Inst", sxInstBuf, &instLinks, sxTemplateBuf);

                        //unput all operands
                        i = strlen(sxOperandsString);
                        while(i-- != 0)
                        {
                        	unput(sxOperandsString[i]);
                        }
                        BEGIN(ASM);
                }
<TOKEN_SX_OP>{ID}|.	{ 	//append all other characters to the buffer
		 	strncat(sxOperandsString, yytext, 255-strlen(sxOperandsString));
		}

%%

#include "colorer.c"
